#!/usr/bin/env python
# -*- coding: utf-8 -*-

# THIS FILE WAS GENERATED BY generate_classes.py - DO NOT EDIT #
# (Generated on 2019-09-11 10:14:02.117530) #

from .base_classes import BaseRequest


class GetVersion(BaseRequest):
    """
    Returns the latest version of the plugin and the API.

    :Returns:
       *version*
            type: double
            OBSRemote compatible API version. Fixed to 1.1 for retrocompatibility.
       *obs_websocket_version*
            type: String
            obs-websocket plugin version.
       *obs_studio_version*
            type: String
            OBS Studio program version.
       *available_requests*
            type: String
            List of available request types, formatted as a comma-separated list string (e.g. : "Method1,Method2,Method3").
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetVersion'
        self._returns['version'] = None
        self._returns['obs-websocket-version'] = None
        self._returns['obs-studio-version'] = None
        self._returns['available-requests'] = None

    @property
    def version(self):
        return self._returns['version']

    @property
    def obs_websocket_version(self):
        return self._returns['obs-websocket-version']

    @property
    def obs_studio_version(self):
        return self._returns['obs-studio-version']

    @property
    def available_requests(self):
        return self._returns['available-requests']


class GetAuthRequired(BaseRequest):
    """
    Tells the client if authentication is required. If so, returns authentication parameters `challenge`
    and `salt` (see "Authentication" for more information).

    :Returns:
       *auth_required*
            type: boolean
            Indicates whether authentication is required.
       *challenge*
            type: String (optional)
            
       *salt*
            type: String (optional)
            
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetAuthRequired'
        self._returns['authRequired'] = None
        self._returns['challenge'] = None
        self._returns['salt'] = None

    @property
    def auth_required(self):
        return self._returns['authRequired']

    @property
    def challenge(self):
        return self._returns['challenge']

    @property
    def salt(self):
        return self._returns['salt']


class Authenticate(BaseRequest):
    """
    Attempt to authenticate the client to the server.

    :Arguments:
       *auth*
            type: String
            Response to the auth challenge (see "Authentication" for more information).
    """
    def __init__(self, auth):
        BaseRequest.__init__(self)
        self._name = 'Authenticate'
        self._params['auth'] = auth


class SetHeartbeat(BaseRequest):
    """
    Enable/disable sending of the Heartbeat event

    :Arguments:
       *enable*
            type: boolean
            Starts/Stops emitting heartbeat messages
    """
    def __init__(self, enable):
        BaseRequest.__init__(self)
        self._name = 'SetHeartbeat'
        self._params['enable'] = enable


class SetFilenameFormatting(BaseRequest):
    """
    Set the filename formatting string

    :Arguments:
       *filename_formatting*
            type: String
            Filename formatting string to set.
    """
    def __init__(self, filename_formatting):
        BaseRequest.__init__(self)
        self._name = 'SetFilenameFormatting'
        self._params['filename-formatting'] = filename_formatting


class GetFilenameFormatting(BaseRequest):
    """
    Get the filename formatting string

    :Returns:
       *filename_formatting*
            type: String
            Current filename formatting string.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetFilenameFormatting'
        self._returns['filename-formatting'] = None

    @property
    def filename_formatting(self):
        return self._returns['filename-formatting']


class GetStats(BaseRequest):
    """
    Get OBS stats (almost the same info as provided in OBS' stats window)

    :Returns:
       *stats*
            type: OBSStats
            OBS stats
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetStats'
        self._returns['stats'] = None

    @property
    def stats(self):
        return self._returns['stats']


class BroadcastCustomMessage(BaseRequest):
    """
    Broadcast custom message to all connected WebSocket clients

    :Arguments:
       *realm*
            type: String
            Identifier to be choosen by the client
       *data*
            type: Object
            User-defined data
    """
    def __init__(self, realm, data):
        BaseRequest.__init__(self)
        self._name = 'BroadcastCustomMessage'
        self._params['realm'] = realm
        self._params['data'] = data


class GetVideoInfo(BaseRequest):
    """
    Get basic OBS video information

    :Returns:
       *base_width*
            type: int
            Base (canvas) width
       *base_height*
            type: int
            Base (canvas) height
       *output_width*
            type: int
            Output width
       *output_height*
            type: int
            Output height
       *scale_type*
            type: String
            Scaling method used if output size differs from base size
       *fps*
            type: double
            Frames rendered per second
       *video_format*
            type: String
            Video color format
       *color_space*
            type: String
            Color space for YUV
       *color_range*
            type: String
            Color range (full or partial)
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetVideoInfo'
        self._returns['baseWidth'] = None
        self._returns['baseHeight'] = None
        self._returns['outputWidth'] = None
        self._returns['outputHeight'] = None
        self._returns['scaleType'] = None
        self._returns['fps'] = None
        self._returns['videoFormat'] = None
        self._returns['colorSpace'] = None
        self._returns['colorRange'] = None

    @property
    def base_width(self):
        return self._returns['baseWidth']

    @property
    def base_height(self):
        return self._returns['baseHeight']

    @property
    def output_width(self):
        return self._returns['outputWidth']

    @property
    def output_height(self):
        return self._returns['outputHeight']

    @property
    def scale_type(self):
        return self._returns['scaleType']

    @property
    def fps(self):
        return self._returns['fps']

    @property
    def video_format(self):
        return self._returns['videoFormat']

    @property
    def color_space(self):
        return self._returns['colorSpace']

    @property
    def color_range(self):
        return self._returns['colorRange']


class ListOutputs(BaseRequest):
    """
    List existing outputs

    :Returns:
       *outputs*
            type: Array<Output>
            Outputs list
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'ListOutputs'
        self._returns['outputs'] = None

    @property
    def outputs(self):
        return self._returns['outputs']


class GetOutputInfo(BaseRequest):
    """
    Get information about a single output

    :Arguments:
       *output_name*
            type: String
            Output name
    :Returns:
       *output_info*
            type: Output
            Output info
    """
    def __init__(self, output_name):
        BaseRequest.__init__(self)
        self._name = 'GetOutputInfo'
        self._returns['outputInfo'] = None
        self._params['outputName'] = output_name

    @property
    def output_info(self):
        return self._returns['outputInfo']


class StartOutput(BaseRequest):
    """
    Start an output

    :Arguments:
       *output_name*
            type: String
            Output name
    """
    def __init__(self, output_name):
        BaseRequest.__init__(self)
        self._name = 'StartOutput'
        self._params['outputName'] = output_name


class StopOutput(BaseRequest):
    """
    Stop an output

    :Arguments:
       *output_name*
            type: String
            Output name
       *force*
            type: boolean (optional)
            Force stop (default: false)
    """
    def __init__(self, output_name, force=None):
        BaseRequest.__init__(self)
        self._name = 'StopOutput'
        self._params['outputName'] = output_name
        self._params['force'] = force


class SetCurrentProfile(BaseRequest):
    """
    Set the currently active profile.

    :Arguments:
       *profile_name*
            type: String
            Name of the desired profile.
    """
    def __init__(self, profile_name):
        BaseRequest.__init__(self)
        self._name = 'SetCurrentProfile'
        self._params['profile-name'] = profile_name


class GetCurrentProfile(BaseRequest):
    """
    Get the name of the current profile.

    :Returns:
       *profile_name*
            type: String
            Name of the currently active profile.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetCurrentProfile'
        self._returns['profile-name'] = None

    @property
    def profile_name(self):
        return self._returns['profile-name']


class ListProfiles(BaseRequest):
    """
    Get a list of available profiles.

    :Returns:
       *profiles*
            type: Array<Object>
            List of available profiles.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'ListProfiles'
        self._returns['profiles'] = None

    @property
    def profiles(self):
        return self._returns['profiles']


class StartStopRecording(BaseRequest):
    """
    Toggle recording on or off.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'StartStopRecording'


class StartRecording(BaseRequest):
    """
    Start recording.
    Will return an `error` if recording is already active.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'StartRecording'


class StopRecording(BaseRequest):
    """
    Stop recording.
    Will return an `error` if recording is not active.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'StopRecording'


class PauseRecording(BaseRequest):
    """
    Pause the current recording.
    Returns an error if recording is not active or already paused.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'PauseRecording'


class ResumeRecording(BaseRequest):
    """
    Resume/unpause the current recording (if paused).
    Returns an error if recording is not active or not paused.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'ResumeRecording'


class SetRecordingFolder(BaseRequest):
    """
    
    
    Please note: if `SetRecordingFolder` is called while a recording is
    in progress, the change won't be applied immediately and will be
    effective on the next recording.

    :Arguments:
       *rec_folder*
            type: String
            Path of the recording folder.
    """
    def __init__(self, rec_folder):
        BaseRequest.__init__(self)
        self._name = 'SetRecordingFolder'
        self._params['rec-folder'] = rec_folder


class GetRecordingFolder(BaseRequest):
    """
    Get the path of  the current recording folder.

    :Returns:
       *rec_folder*
            type: String
            Path of the recording folder.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetRecordingFolder'
        self._returns['rec-folder'] = None

    @property
    def rec_folder(self):
        return self._returns['rec-folder']


class StartStopReplayBuffer(BaseRequest):
    """
    Toggle the Replay Buffer on/off.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'StartStopReplayBuffer'


class StartReplayBuffer(BaseRequest):
    """
    Start recording into the Replay Buffer.
    Will return an `error` if the Replay Buffer is already active or if the
    "Save Replay Buffer" hotkey is not set in OBS' settings.
    Setting this hotkey is mandatory, even when triggering saves only
    through obs-websocket.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'StartReplayBuffer'


class StopReplayBuffer(BaseRequest):
    """
    Stop recording into the Replay Buffer.
    Will return an `error` if the Replay Buffer is not active.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'StopReplayBuffer'


class SaveReplayBuffer(BaseRequest):
    """
    Flush and save the contents of the Replay Buffer to disk. This is
    basically the same as triggering the "Save Replay Buffer" hotkey.
    Will return an `error` if the Replay Buffer is not active.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'SaveReplayBuffer'


class SetCurrentSceneCollection(BaseRequest):
    """
    Change the active scene collection.

    :Arguments:
       *sc_name*
            type: String
            Name of the desired scene collection.
    """
    def __init__(self, sc_name):
        BaseRequest.__init__(self)
        self._name = 'SetCurrentSceneCollection'
        self._params['sc-name'] = sc_name


class GetCurrentSceneCollection(BaseRequest):
    """
    Get the name of the current scene collection.

    :Returns:
       *sc_name*
            type: String
            Name of the currently active scene collection.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetCurrentSceneCollection'
        self._returns['sc-name'] = None

    @property
    def sc_name(self):
        return self._returns['sc-name']


class ListSceneCollections(BaseRequest):
    """
    List available scene collections

    :Returns:
       *scene_collections*
            type: Array<String>
            Scene collections list
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'ListSceneCollections'
        self._returns['scene-collections'] = None

    @property
    def scene_collections(self):
        return self._returns['scene-collections']


class GetSceneItemProperties(BaseRequest):
    """
    Gets the scene specific properties of the specified source item.
    Coordinates are relative to the item's parent (the scene or group it belongs to).

    :Arguments:
       *scene_name*
            type: String (optional)
            the name of the scene that the source item belongs to. Defaults to the current scene.
       *item*
            type: String
            The name of the source.
    :Returns:
       *name*
            type: String
            The name of the source.
       *position.x*
            type: int
            The x position of the source from the left.
       *position.y*
            type: int
            The y position of the source from the top.
       *position.alignment*
            type: int
            The point on the source that the item is manipulated from.
       *rotation*
            type: double
            The clockwise rotation of the item in degrees around the point of alignment.
       *scale.x*
            type: double
            The x-scale factor of the source.
       *scale.y*
            type: double
            The y-scale factor of the source.
       *crop.top*
            type: int
            The number of pixels cropped off the top of the source before scaling.
       *crop.right*
            type: int
            The number of pixels cropped off the right of the source before scaling.
       *crop.bottom*
            type: int
            The number of pixels cropped off the bottom of the source before scaling.
       *crop.left*
            type: int
            The number of pixels cropped off the left of the source before scaling.
       *visible*
            type: bool
            If the source is visible.
       *locked*
            type: bool
            If the source's transform is locked.
       *bounds.type*
            type: String
            Type of bounding box. Can be "OBS_BOUNDS_STRETCH", "OBS_BOUNDS_SCALE_INNER", "OBS_BOUNDS_SCALE_OUTER", "OBS_BOUNDS_SCALE_TO_WIDTH", "OBS_BOUNDS_SCALE_TO_HEIGHT", "OBS_BOUNDS_MAX_ONLY" or "OBS_BOUNDS_NONE".
       *bounds.alignment*
            type: int
            Alignment of the bounding box.
       *bounds.x*
            type: double
            Width of the bounding box.
       *bounds.y*
            type: double
            Height of the bounding box.
       *source_width*
            type: int
            Base width (without scaling) of the source
       *source_height*
            type: int
            Base source (without scaling) of the source
       *width*
            type: double
            Scene item width (base source width multiplied by the horizontal scaling factor)
       *height*
            type: double
            Scene item height (base source height multiplied by the vertical scaling factor)
    """
    def __init__(self, item, scene_name=None):
        BaseRequest.__init__(self)
        self._name = 'GetSceneItemProperties'
        self._returns['name'] = None
        self._returns['rotation'] = None
        self._returns['visible'] = None
        self._returns['locked'] = None
        self._returns['sourceWidth'] = None
        self._returns['sourceHeight'] = None
        self._returns['width'] = None
        self._returns['height'] = None
        self._params['item'] = item
        self._params['scene-name'] = scene_name

    @property
    def name(self):
        return self._returns['name']

    @property
    def rotation(self):
        return self._returns['rotation']

    @property
    def visible(self):
        return self._returns['visible']

    @property
    def locked(self):
        return self._returns['locked']

    @property
    def source_width(self):
        return self._returns['sourceWidth']

    @property
    def source_height(self):
        return self._returns['sourceHeight']

    @property
    def width(self):
        return self._returns['width']

    @property
    def height(self):
        return self._returns['height']


class SetSceneItemProperties(BaseRequest):
    """
    Sets the scene specific properties of a source. Unspecified properties will remain unchanged.
    Coordinates are relative to the item's parent (the scene or group it belongs to).

    :Arguments:
       *scene_name*
            type: String (optional)
            the name of the scene that the source item belongs to. Defaults to the current scene.
       *item*
            type: String
            The name of the source.
       *position.x*
            type: int (optional)
            The new x position of the source.
       *position.y*
            type: int (optional)
            The new y position of the source.
       *position.alignment*
            type: int (optional)
            The new alignment of the source.
       *rotation*
            type: double (optional)
            The new clockwise rotation of the item in degrees.
       *scale.x*
            type: double (optional)
            The new x scale of the item.
       *scale.y*
            type: double (optional)
            The new y scale of the item.
       *crop.top*
            type: int (optional)
            The new amount of pixels cropped off the top of the source before scaling.
       *crop.bottom*
            type: int (optional)
            The new amount of pixels cropped off the bottom of the source before scaling.
       *crop.left*
            type: int (optional)
            The new amount of pixels cropped off the left of the source before scaling.
       *crop.right*
            type: int (optional)
            The new amount of pixels cropped off the right of the source before scaling.
       *visible*
            type: bool (optional)
            The new visibility of the source. 'true' shows source, 'false' hides source.
       *locked*
            type: bool (optional)
            The new locked status of the source. 'true' keeps it in its current position, 'false' allows movement.
       *bounds.type*
            type: String (optional)
            The new bounds type of the source. Can be "OBS_BOUNDS_STRETCH", "OBS_BOUNDS_SCALE_INNER", "OBS_BOUNDS_SCALE_OUTER", "OBS_BOUNDS_SCALE_TO_WIDTH", "OBS_BOUNDS_SCALE_TO_HEIGHT", "OBS_BOUNDS_MAX_ONLY" or "OBS_BOUNDS_NONE".
       *bounds.alignment*
            type: int (optional)
            The new alignment of the bounding box. (0-2, 4-6, 8-10)
       *bounds.x*
            type: double (optional)
            The new width of the bounding box.
       *bounds.y*
            type: double (optional)
            The new height of the bounding box.
    """
    def __init__(self, item, scene_name=None, rotation=None, visible=None, locked=None):
        BaseRequest.__init__(self)
        self._name = 'SetSceneItemProperties'
        self._params['item'] = item
        self._params['scene-name'] = scene_name
        self._params['rotation'] = rotation
        self._params['visible'] = visible
        self._params['locked'] = locked


class ResetSceneItem(BaseRequest):
    """
    Reset a scene item.

    :Arguments:
       *scene_name*
            type: String (optional)
            Name of the scene the source belongs to. Defaults to the current scene.
       *item*
            type: String
            Name of the source item.
    """
    def __init__(self, item, scene_name=None):
        BaseRequest.__init__(self)
        self._name = 'ResetSceneItem'
        self._params['item'] = item
        self._params['scene-name'] = scene_name


class SetSceneItemRender(BaseRequest):
    """
    Show or hide a specified source item in a specified scene.

    :Arguments:
       *source*
            type: String
            Scene item name in the specified scene.
       *render*
            type: boolean
            true = shown ; false = hidden
       *scene_name*
            type: String (optional)
            Name of the scene where the source resides. Defaults to the currently active scene.
    """
    def __init__(self, source, render, scene_name=None):
        BaseRequest.__init__(self)
        self._name = 'SetSceneItemRender'
        self._params['source'] = source
        self._params['render'] = render
        self._params['scene-name'] = scene_name


class SetSceneItemPosition(BaseRequest):
    """
    Sets the coordinates of a specified source item.

    :Arguments:
       *scene_name*
            type: String (optional)
            The name of the scene that the source item belongs to. Defaults to the current scene.
       *item*
            type: String
            The name of the source item.
       *x*
            type: double
            X coordinate.
       *y*
            type: double
            Y coordinate.
    """
    def __init__(self, item, x, y, scene_name=None):
        BaseRequest.__init__(self)
        self._name = 'SetSceneItemPosition'
        self._params['item'] = item
        self._params['x'] = x
        self._params['y'] = y
        self._params['scene-name'] = scene_name


class SetSceneItemTransform(BaseRequest):
    """
    Set the transform of the specified source item.

    :Arguments:
       *scene_name*
            type: String (optional)
            The name of the scene that the source item belongs to. Defaults to the current scene.
       *item*
            type: String
            The name of the source item.
       *x_scale*
            type: double
            Width scale factor.
       *y_scale*
            type: double
            Height scale factor.
       *rotation*
            type: double
            Source item rotation (in degrees).
    """
    def __init__(self, item, x_scale, y_scale, rotation, scene_name=None):
        BaseRequest.__init__(self)
        self._name = 'SetSceneItemTransform'
        self._params['item'] = item
        self._params['x-scale'] = x_scale
        self._params['y-scale'] = y_scale
        self._params['rotation'] = rotation
        self._params['scene-name'] = scene_name


class SetSceneItemCrop(BaseRequest):
    """
    Sets the crop coordinates of the specified source item.

    :Arguments:
       *scene_name*
            type: String (optional)
            the name of the scene that the source item belongs to. Defaults to the current scene.
       *item*
            type: String
            The name of the source.
       *top*
            type: int
            Pixel position of the top of the source item.
       *bottom*
            type: int
            Pixel position of the bottom of the source item.
       *left*
            type: int
            Pixel position of the left of the source item.
       *right*
            type: int
            Pixel position of the right of the source item.
    """
    def __init__(self, item, top, bottom, left, right, scene_name=None):
        BaseRequest.__init__(self)
        self._name = 'SetSceneItemCrop'
        self._params['item'] = item
        self._params['top'] = top
        self._params['bottom'] = bottom
        self._params['left'] = left
        self._params['right'] = right
        self._params['scene-name'] = scene_name


class DeleteSceneItem(BaseRequest):
    """
    Deletes a scene item.

    :Arguments:
       *scene*
            type: String (optional)
            Name of the scene the source belongs to. Defaults to the current scene.
       *item*
            type: Object
            item to delete (required)
       *item.name*
            type: String
            name of the scene item (prefer `id`, including both is acceptable).
       *item.id*
            type: int
            id of the scene item.
    """
    def __init__(self, item, scene=None):
        BaseRequest.__init__(self)
        self._name = 'DeleteSceneItem'
        self._params['item'] = item
        self._params['scene'] = scene


class DuplicateSceneItem(BaseRequest):
    """
    Duplicates a scene item.

    :Arguments:
       *from_scene*
            type: String (optional)
            Name of the scene to copy the item from. Defaults to the current scene.
       *to_scene*
            type: String (optional)
            Name of the scene to create the item in. Defaults to the current scene.
       *item*
            type: Object
            item to duplicate (required)
       *item.name*
            type: String
            name of the scene item (prefer `id`, including both is acceptable).
       *item.id*
            type: int
            id of the scene item.
    :Returns:
       *scene*
            type: String
            Name of the scene where the new item was created
       *item*
            type: Object
            New item info
       *item.id*
            type: int
            New item ID
       *item.name*
            type: String
            New item name
    """
    def __init__(self, item, from_scene=None, to_scene=None):
        BaseRequest.__init__(self)
        self._name = 'DuplicateSceneItem'
        self._returns['scene'] = None
        self._returns['item'] = None
        self._params['item'] = item
        self._params['fromScene'] = from_scene
        self._params['toScene'] = to_scene

    @property
    def scene(self):
        return self._returns['scene']

    @property
    def item(self):
        return self._returns['item']


class SetCurrentScene(BaseRequest):
    """
    Switch to the specified scene.

    :Arguments:
       *scene_name*
            type: String
            Name of the scene to switch to.
    """
    def __init__(self, scene_name):
        BaseRequest.__init__(self)
        self._name = 'SetCurrentScene'
        self._params['scene-name'] = scene_name


class GetCurrentScene(BaseRequest):
    """
    Get the current scene's name and source items.

    :Returns:
       *name*
            type: String
            Name of the currently active scene.
       *sources*
            type: Array<SceneItem>
            Ordered list of the current scene's source items.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetCurrentScene'
        self._returns['name'] = None
        self._returns['sources'] = None

    @property
    def name(self):
        return self._returns['name']

    @property
    def sources(self):
        return self._returns['sources']


class GetSceneList(BaseRequest):
    """
    Get a list of scenes in the currently active profile.

    :Returns:
       *current_scene*
            type: String
            Name of the currently active scene.
       *scenes*
            type: Array<Scene>
            Ordered list of the current profile's scenes (See `[GetCurrentScene](#getcurrentscene)` for more information).
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetSceneList'
        self._returns['current-scene'] = None
        self._returns['scenes'] = None

    @property
    def current_scene(self):
        return self._returns['current-scene']

    @property
    def scenes(self):
        return self._returns['scenes']


class ReorderSceneItems(BaseRequest):
    """
    Changes the order of scene items in the requested scene.

    :Arguments:
       *scene*
            type: String (optional)
            Name of the scene to reorder (defaults to current).
       *items*
            type: Array<Scene>
            Ordered list of objects with name and/or id specified. Id preferred due to uniqueness per scene
       *items[].id*
            type: int (optional)
            Id of a specific scene item. Unique on a scene by scene basis.
       *items[].name*
            type: String (optional)
            Name of a scene item. Sufficiently unique if no scene items share sources within the scene.
    """
    def __init__(self, items, scene=None):
        BaseRequest.__init__(self)
        self._name = 'ReorderSceneItems'
        self._params['items'] = items
        self._params['scene'] = scene


class GetSourcesList(BaseRequest):
    """
    List all sources available in the running OBS instance

    :Returns:
       *sources*
            type: Array<Object>
            Array of sources
       *sources.*.name*
            type: String
            Unique source name
       *sources.*.type_id*
            type: String
            Non-unique source internal type (a.k.a type id)
       *sources.*.type*
            type: String
            Source type. Value is one of the following: "input", "filter", "transition", "scene" or "unknown"
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetSourcesList'
        self._returns['sources'] = None

    @property
    def sources(self):
        return self._returns['sources']


class GetSourceTypesList(BaseRequest):
    """
    Get a list of all available sources types

    :Returns:
       *types*
            type: Array<Object>
            Array of source types
       *types.*.type_id*
            type: String
            Non-unique internal source type ID
       *types.*.display_name*
            type: String
            Display name of the source type
       *types.*.type*
            type: String
            Type. Value is one of the following: "input", "filter", "transition" or "other"
       *types.*.default_settings*
            type: Object
            Default settings of this source type
       *types.*.caps*
            type: Object
            Source type capabilities
       *types.*.caps.is_async*
            type: Boolean
            True if source of this type provide frames asynchronously
       *types.*.caps.has_video*
            type: Boolean
            True if sources of this type provide video
       *types.*.caps.has_audio*
            type: Boolean
            True if sources of this type provide audio
       *types.*.caps.can_interact*
            type: Boolean
            True if interaction with this sources of this type is possible
       *types.*.caps.is_composite*
            type: Boolean
            True if sources of this type composite one or more sub-sources
       *types.*.caps.do_not_duplicate*
            type: Boolean
            True if sources of this type should not be fully duplicated
       *types.*.caps.do_not_self_monitor*
            type: Boolean
            True if sources of this type may cause a feedback loop if it's audio is monitored and shouldn't be
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetSourceTypesList'
        self._returns['types'] = None

    @property
    def types(self):
        return self._returns['types']


class GetVolume(BaseRequest):
    """
    Get the volume of the specified source.

    :Arguments:
       *source*
            type: String
            Source name.
    :Returns:
       *name*
            type: String
            Source name.
       *volume*
            type: double
            Volume of the source. Between `0.0` and `1.0`.
       *muted*
            type: boolean
            Indicates whether the source is muted.
    """
    def __init__(self, source):
        BaseRequest.__init__(self)
        self._name = 'GetVolume'
        self._returns['name'] = None
        self._returns['volume'] = None
        self._returns['muted'] = None
        self._params['source'] = source

    @property
    def name(self):
        return self._returns['name']

    @property
    def volume(self):
        return self._returns['volume']

    @property
    def muted(self):
        return self._returns['muted']


class SetVolume(BaseRequest):
    """
    Set the volume of the specified source.

    :Arguments:
       *source*
            type: String
            Source name.
       *volume*
            type: double
            Desired volume. Must be between `0.0` and `1.0`.
    """
    def __init__(self, source, volume):
        BaseRequest.__init__(self)
        self._name = 'SetVolume'
        self._params['source'] = source
        self._params['volume'] = volume


class GetMute(BaseRequest):
    """
    Get the mute status of a specified source.

    :Arguments:
       *source*
            type: String
            Source name.
    :Returns:
       *name*
            type: String
            Source name.
       *muted*
            type: boolean
            Mute status of the source.
    """
    def __init__(self, source):
        BaseRequest.__init__(self)
        self._name = 'GetMute'
        self._returns['name'] = None
        self._returns['muted'] = None
        self._params['source'] = source

    @property
    def name(self):
        return self._returns['name']

    @property
    def muted(self):
        return self._returns['muted']


class SetMute(BaseRequest):
    """
    Sets the mute status of a specified source.

    :Arguments:
       *source*
            type: String
            Source name.
       *mute*
            type: boolean
            Desired mute status.
    """
    def __init__(self, source, mute):
        BaseRequest.__init__(self)
        self._name = 'SetMute'
        self._params['source'] = source
        self._params['mute'] = mute


class ToggleMute(BaseRequest):
    """
    Inverts the mute status of a specified source.

    :Arguments:
       *source*
            type: String
            Source name.
    """
    def __init__(self, source):
        BaseRequest.__init__(self)
        self._name = 'ToggleMute'
        self._params['source'] = source


class SetSyncOffset(BaseRequest):
    """
    Set the audio sync offset of a specified source.

    :Arguments:
       *source*
            type: String
            Source name.
       *offset*
            type: int
            The desired audio sync offset (in nanoseconds).
    """
    def __init__(self, source, offset):
        BaseRequest.__init__(self)
        self._name = 'SetSyncOffset'
        self._params['source'] = source
        self._params['offset'] = offset


class GetSyncOffset(BaseRequest):
    """
    Get the audio sync offset of a specified source.

    :Arguments:
       *source*
            type: String
            Source name.
    :Returns:
       *name*
            type: String
            Source name.
       *offset*
            type: int
            The audio sync offset (in nanoseconds).
    """
    def __init__(self, source):
        BaseRequest.__init__(self)
        self._name = 'GetSyncOffset'
        self._returns['name'] = None
        self._returns['offset'] = None
        self._params['source'] = source

    @property
    def name(self):
        return self._returns['name']

    @property
    def offset(self):
        return self._returns['offset']


class GetSourceSettings(BaseRequest):
    """
    Get settings of the specified source

    :Arguments:
       *source_name*
            type: String
            Source name.
       *source_type*
            type: String (optional)
            Type of the specified source. Useful for type-checking if you expect a specific settings schema.
    :Returns:
       *source_name*
            type: String
            Source name
       *source_type*
            type: String
            Type of the specified source
       *source_settings*
            type: Object
            Source settings (varies between source types, may require some probing around).
    """
    def __init__(self, source_name, source_type=None):
        BaseRequest.__init__(self)
        self._name = 'GetSourceSettings'
        self._returns['sourceName'] = None
        self._returns['sourceType'] = None
        self._returns['sourceSettings'] = None
        self._params['sourceName'] = source_name
        self._params['sourceType'] = source_type

    @property
    def source_name(self):
        return self._returns['sourceName']

    @property
    def source_type(self):
        return self._returns['sourceType']

    @property
    def source_settings(self):
        return self._returns['sourceSettings']


class SetSourceSettings(BaseRequest):
    """
    Set settings of the specified source.

    :Arguments:
       *source_name*
            type: String
            Source name.
       *source_type*
            type: String (optional)
            Type of the specified source. Useful for type-checking to avoid settings a set of settings incompatible with the actual source's type.
       *source_settings*
            type: Object
            Source settings (varies between source types, may require some probing around).
    :Returns:
       *source_name*
            type: String
            Source name
       *source_type*
            type: String
            Type of the specified source
       *source_settings*
            type: Object
            Updated source settings
    """
    def __init__(self, source_name, source_settings, source_type=None):
        BaseRequest.__init__(self)
        self._name = 'SetSourceSettings'
        self._returns['sourceName'] = None
        self._returns['sourceType'] = None
        self._returns['sourceSettings'] = None
        self._params['sourceName'] = source_name
        self._params['sourceSettings'] = source_settings
        self._params['sourceType'] = source_type

    @property
    def source_name(self):
        return self._returns['sourceName']

    @property
    def source_type(self):
        return self._returns['sourceType']

    @property
    def source_settings(self):
        return self._returns['sourceSettings']


class GetTextGDIPlusProperties(BaseRequest):
    """
    Get the current properties of a Text GDI Plus source.

    :Arguments:
       *source*
            type: String
            Source name.
    :Returns:
       *source*
            type: String
            Source name.
       *align*
            type: String
            Text Alignment ("left", "center", "right").
       *bk_color*
            type: int
            Background color.
       *bk_opacity*
            type: int
            Background opacity (0-100).
       *chatlog*
            type: boolean
            Chat log.
       *chatlog_lines*
            type: int
            Chat log lines.
       *color*
            type: int
            Text color.
       *extents*
            type: boolean
            Extents wrap.
       *extents_cx*
            type: int
            Extents cx.
       *extents_cy*
            type: int
            Extents cy.
       *file*
            type: String
            File path name.
       *read_from_file*
            type: boolean
            Read text from the specified file.
       *font*
            type: Object
            Holds data for the font. Ex: `"font": { "face": "Arial", "flags": 0, "size": 150, "style": "" }`
       *font.face*
            type: String
            Font face.
       *font.flags*
            type: int
            Font text styling flag. `Bold=1, Italic=2, Bold Italic=3, Underline=5, Strikeout=8`
       *font.size*
            type: int
            Font text size.
       *font.style*
            type: String
            Font Style (unknown function).
       *gradient*
            type: boolean
            Gradient enabled.
       *gradient_color*
            type: int
            Gradient color.
       *gradient_dir*
            type: float
            Gradient direction.
       *gradient_opacity*
            type: int
            Gradient opacity (0-100).
       *outline*
            type: boolean
            Outline.
       *outline_color*
            type: int
            Outline color.
       *outline_size*
            type: int
            Outline size.
       *outline_opacity*
            type: int
            Outline opacity (0-100).
       *text*
            type: String
            Text content to be displayed.
       *valign*
            type: String
            Text vertical alignment ("top", "center", "bottom").
       *vertical*
            type: boolean
            Vertical text enabled.
    """
    def __init__(self, source):
        BaseRequest.__init__(self)
        self._name = 'GetTextGDIPlusProperties'
        self._returns['source'] = None
        self._returns['align'] = None
        self._returns['bk-color'] = None
        self._returns['bk-opacity'] = None
        self._returns['chatlog'] = None
        self._returns['chatlog_lines'] = None
        self._returns['color'] = None
        self._returns['extents'] = None
        self._returns['extents_cx'] = None
        self._returns['extents_cy'] = None
        self._returns['file'] = None
        self._returns['read_from_file'] = None
        self._returns['font'] = None
        self._returns['gradient'] = None
        self._returns['gradient_color'] = None
        self._returns['gradient_dir'] = None
        self._returns['gradient_opacity'] = None
        self._returns['outline'] = None
        self._returns['outline_color'] = None
        self._returns['outline_size'] = None
        self._returns['outline_opacity'] = None
        self._returns['text'] = None
        self._returns['valign'] = None
        self._returns['vertical'] = None
        self._params['source'] = source

    @property
    def source(self):
        return self._returns['source']

    @property
    def align(self):
        return self._returns['align']

    @property
    def bk_color(self):
        return self._returns['bk-color']

    @property
    def bk_opacity(self):
        return self._returns['bk-opacity']

    @property
    def chatlog(self):
        return self._returns['chatlog']

    @property
    def chatlog_lines(self):
        return self._returns['chatlog_lines']

    @property
    def color(self):
        return self._returns['color']

    @property
    def extents(self):
        return self._returns['extents']

    @property
    def extents_cx(self):
        return self._returns['extents_cx']

    @property
    def extents_cy(self):
        return self._returns['extents_cy']

    @property
    def file(self):
        return self._returns['file']

    @property
    def read_from_file(self):
        return self._returns['read_from_file']

    @property
    def font(self):
        return self._returns['font']

    @property
    def gradient(self):
        return self._returns['gradient']

    @property
    def gradient_color(self):
        return self._returns['gradient_color']

    @property
    def gradient_dir(self):
        return self._returns['gradient_dir']

    @property
    def gradient_opacity(self):
        return self._returns['gradient_opacity']

    @property
    def outline(self):
        return self._returns['outline']

    @property
    def outline_color(self):
        return self._returns['outline_color']

    @property
    def outline_size(self):
        return self._returns['outline_size']

    @property
    def outline_opacity(self):
        return self._returns['outline_opacity']

    @property
    def text(self):
        return self._returns['text']

    @property
    def valign(self):
        return self._returns['valign']

    @property
    def vertical(self):
        return self._returns['vertical']


class SetTextGDIPlusProperties(BaseRequest):
    """
    Set the current properties of a Text GDI Plus source.

    :Arguments:
       *source*
            type: String
            Name of the source.
       *align*
            type: String (optional)
            Text Alignment ("left", "center", "right").
       *bk_color*
            type: int (optional)
            Background color.
       *bk_opacity*
            type: int (optional)
            Background opacity (0-100).
       *chatlog*
            type: boolean (optional)
            Chat log.
       *chatlog_lines*
            type: int (optional)
            Chat log lines.
       *color*
            type: int (optional)
            Text color.
       *extents*
            type: boolean (optional)
            Extents wrap.
       *extents_cx*
            type: int (optional)
            Extents cx.
       *extents_cy*
            type: int (optional)
            Extents cy.
       *file*
            type: String (optional)
            File path name.
       *read_from_file*
            type: boolean (optional)
            Read text from the specified file.
       *font*
            type: Object (optional)
            Holds data for the font. Ex: `"font": { "face": "Arial", "flags": 0, "size": 150, "style": "" }`
       *font.face*
            type: String (optional)
            Font face.
       *font.flags*
            type: int (optional)
            Font text styling flag. `Bold=1, Italic=2, Bold Italic=3, Underline=5, Strikeout=8`
       *font.size*
            type: int (optional)
            Font text size.
       *font.style*
            type: String (optional)
            Font Style (unknown function).
       *gradient*
            type: boolean (optional)
            Gradient enabled.
       *gradient_color*
            type: int (optional)
            Gradient color.
       *gradient_dir*
            type: float (optional)
            Gradient direction.
       *gradient_opacity*
            type: int (optional)
            Gradient opacity (0-100).
       *outline*
            type: boolean (optional)
            Outline.
       *outline_color*
            type: int (optional)
            Outline color.
       *outline_size*
            type: int (optional)
            Outline size.
       *outline_opacity*
            type: int (optional)
            Outline opacity (0-100).
       *text*
            type: String (optional)
            Text content to be displayed.
       *valign*
            type: String (optional)
            Text vertical alignment ("top", "center", "bottom").
       *vertical*
            type: boolean (optional)
            Vertical text enabled.
       *render*
            type: boolean (optional)
            Visibility of the scene item.
    """
    def __init__(self, source, align=None, bk_color=None, bk_opacity=None, chatlog=None, chatlog_lines=None, color=None, extents=None, extents_cx=None, extents_cy=None, file=None, read_from_file=None, font=None, gradient=None, gradient_color=None, gradient_dir=None, gradient_opacity=None, outline=None, outline_color=None, outline_size=None, outline_opacity=None, text=None, valign=None, vertical=None, render=None):
        BaseRequest.__init__(self)
        self._name = 'SetTextGDIPlusProperties'
        self._params['source'] = source
        self._params['align'] = align
        self._params['bk-color'] = bk_color
        self._params['bk-opacity'] = bk_opacity
        self._params['chatlog'] = chatlog
        self._params['chatlog_lines'] = chatlog_lines
        self._params['color'] = color
        self._params['extents'] = extents
        self._params['extents_cx'] = extents_cx
        self._params['extents_cy'] = extents_cy
        self._params['file'] = file
        self._params['read_from_file'] = read_from_file
        self._params['font'] = font
        self._params['gradient'] = gradient
        self._params['gradient_color'] = gradient_color
        self._params['gradient_dir'] = gradient_dir
        self._params['gradient_opacity'] = gradient_opacity
        self._params['outline'] = outline
        self._params['outline_color'] = outline_color
        self._params['outline_size'] = outline_size
        self._params['outline_opacity'] = outline_opacity
        self._params['text'] = text
        self._params['valign'] = valign
        self._params['vertical'] = vertical
        self._params['render'] = render


class GetTextFreetype2Properties(BaseRequest):
    """
    Get the current properties of a Text Freetype 2 source.

    :Arguments:
       *source*
            type: String
            Source name.
    :Returns:
       *source*
            type: String
            Source name
       *color1*
            type: int
            Gradient top color.
       *color2*
            type: int
            Gradient bottom color.
       *custom_width*
            type: int
            Custom width (0 to disable).
       *drop_shadow*
            type: boolean
            Drop shadow.
       *font*
            type: Object
            Holds data for the font. Ex: `"font": { "face": "Arial", "flags": 0, "size": 150, "style": "" }`
       *font.face*
            type: String
            Font face.
       *font.flags*
            type: int
            Font text styling flag. `Bold=1, Italic=2, Bold Italic=3, Underline=5, Strikeout=8`
       *font.size*
            type: int
            Font text size.
       *font.style*
            type: String
            Font Style (unknown function).
       *from_file*
            type: boolean
            Read text from the specified file.
       *log_mode*
            type: boolean
            Chat log.
       *outline*
            type: boolean
            Outline.
       *text*
            type: String
            Text content to be displayed.
       *text_file*
            type: String
            File path.
       *word_wrap*
            type: boolean
            Word wrap.
    """
    def __init__(self, source):
        BaseRequest.__init__(self)
        self._name = 'GetTextFreetype2Properties'
        self._returns['source'] = None
        self._returns['color1'] = None
        self._returns['color2'] = None
        self._returns['custom_width'] = None
        self._returns['drop_shadow'] = None
        self._returns['font'] = None
        self._returns['from_file'] = None
        self._returns['log_mode'] = None
        self._returns['outline'] = None
        self._returns['text'] = None
        self._returns['text_file'] = None
        self._returns['word_wrap'] = None
        self._params['source'] = source

    @property
    def source(self):
        return self._returns['source']

    @property
    def color1(self):
        return self._returns['color1']

    @property
    def color2(self):
        return self._returns['color2']

    @property
    def custom_width(self):
        return self._returns['custom_width']

    @property
    def drop_shadow(self):
        return self._returns['drop_shadow']

    @property
    def font(self):
        return self._returns['font']

    @property
    def from_file(self):
        return self._returns['from_file']

    @property
    def log_mode(self):
        return self._returns['log_mode']

    @property
    def outline(self):
        return self._returns['outline']

    @property
    def text(self):
        return self._returns['text']

    @property
    def text_file(self):
        return self._returns['text_file']

    @property
    def word_wrap(self):
        return self._returns['word_wrap']


class SetTextFreetype2Properties(BaseRequest):
    """
    Set the current properties of a Text Freetype 2 source.

    :Arguments:
       *source*
            type: String
            Source name.
       *color1*
            type: int (optional)
            Gradient top color.
       *color2*
            type: int (optional)
            Gradient bottom color.
       *custom_width*
            type: int (optional)
            Custom width (0 to disable).
       *drop_shadow*
            type: boolean (optional)
            Drop shadow.
       *font*
            type: Object (optional)
            Holds data for the font. Ex: `"font": { "face": "Arial", "flags": 0, "size": 150, "style": "" }`
       *font.face*
            type: String (optional)
            Font face.
       *font.flags*
            type: int (optional)
            Font text styling flag. `Bold=1, Italic=2, Bold Italic=3, Underline=5, Strikeout=8`
       *font.size*
            type: int (optional)
            Font text size.
       *font.style*
            type: String (optional)
            Font Style (unknown function).
       *from_file*
            type: boolean (optional)
            Read text from the specified file.
       *log_mode*
            type: boolean (optional)
            Chat log.
       *outline*
            type: boolean (optional)
            Outline.
       *text*
            type: String (optional)
            Text content to be displayed.
       *text_file*
            type: String (optional)
            File path.
       *word_wrap*
            type: boolean (optional)
            Word wrap.
    """
    def __init__(self, source, color1=None, color2=None, custom_width=None, drop_shadow=None, font=None, from_file=None, log_mode=None, outline=None, text=None, text_file=None, word_wrap=None):
        BaseRequest.__init__(self)
        self._name = 'SetTextFreetype2Properties'
        self._params['source'] = source
        self._params['color1'] = color1
        self._params['color2'] = color2
        self._params['custom_width'] = custom_width
        self._params['drop_shadow'] = drop_shadow
        self._params['font'] = font
        self._params['from_file'] = from_file
        self._params['log_mode'] = log_mode
        self._params['outline'] = outline
        self._params['text'] = text
        self._params['text_file'] = text_file
        self._params['word_wrap'] = word_wrap


class GetBrowserSourceProperties(BaseRequest):
    """
    Get current properties for a Browser Source.

    :Arguments:
       *source*
            type: String
            Source name.
    :Returns:
       *source*
            type: String
            Source name.
       *is_local_file*
            type: boolean
            Indicates that a local file is in use.
       *local_file*
            type: String
            file path.
       *url*
            type: String
            Url.
       *css*
            type: String
            CSS to inject.
       *width*
            type: int
            Width.
       *height*
            type: int
            Height.
       *fps*
            type: int
            Framerate.
       *shutdown*
            type: boolean
            Indicates whether the source should be shutdown when not visible.
    """
    def __init__(self, source):
        BaseRequest.__init__(self)
        self._name = 'GetBrowserSourceProperties'
        self._returns['source'] = None
        self._returns['is_local_file'] = None
        self._returns['local_file'] = None
        self._returns['url'] = None
        self._returns['css'] = None
        self._returns['width'] = None
        self._returns['height'] = None
        self._returns['fps'] = None
        self._returns['shutdown'] = None
        self._params['source'] = source

    @property
    def source(self):
        return self._returns['source']

    @property
    def is_local_file(self):
        return self._returns['is_local_file']

    @property
    def local_file(self):
        return self._returns['local_file']

    @property
    def url(self):
        return self._returns['url']

    @property
    def css(self):
        return self._returns['css']

    @property
    def width(self):
        return self._returns['width']

    @property
    def height(self):
        return self._returns['height']

    @property
    def fps(self):
        return self._returns['fps']

    @property
    def shutdown(self):
        return self._returns['shutdown']


class SetBrowserSourceProperties(BaseRequest):
    """
    Set current properties for a Browser Source.

    :Arguments:
       *source*
            type: String
            Name of the source.
       *is_local_file*
            type: boolean (optional)
            Indicates that a local file is in use.
       *local_file*
            type: String (optional)
            file path.
       *url*
            type: String (optional)
            Url.
       *css*
            type: String (optional)
            CSS to inject.
       *width*
            type: int (optional)
            Width.
       *height*
            type: int (optional)
            Height.
       *fps*
            type: int (optional)
            Framerate.
       *shutdown*
            type: boolean (optional)
            Indicates whether the source should be shutdown when not visible.
       *render*
            type: boolean (optional)
            Visibility of the scene item.
    """
    def __init__(self, source, is_local_file=None, local_file=None, url=None, css=None, width=None, height=None, fps=None, shutdown=None, render=None):
        BaseRequest.__init__(self)
        self._name = 'SetBrowserSourceProperties'
        self._params['source'] = source
        self._params['is_local_file'] = is_local_file
        self._params['local_file'] = local_file
        self._params['url'] = url
        self._params['css'] = css
        self._params['width'] = width
        self._params['height'] = height
        self._params['fps'] = fps
        self._params['shutdown'] = shutdown
        self._params['render'] = render


class GetSpecialSources(BaseRequest):
    """
    Get configured special sources like Desktop Audio and Mic/Aux sources.

    :Returns:
       *desktop_1*
            type: String (optional)
            Name of the first Desktop Audio capture source.
       *desktop_2*
            type: String (optional)
            Name of the second Desktop Audio capture source.
       *mic_1*
            type: String (optional)
            Name of the first Mic/Aux input source.
       *mic_2*
            type: String (optional)
            Name of the second Mic/Aux input source.
       *mic_3*
            type: String (optional)
            NAme of the third Mic/Aux input source.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetSpecialSources'
        self._returns['desktop-1'] = None
        self._returns['desktop-2'] = None
        self._returns['mic-1'] = None
        self._returns['mic-2'] = None
        self._returns['mic-3'] = None

    @property
    def desktop_1(self):
        return self._returns['desktop-1']

    @property
    def desktop_2(self):
        return self._returns['desktop-2']

    @property
    def mic_1(self):
        return self._returns['mic-1']

    @property
    def mic_2(self):
        return self._returns['mic-2']

    @property
    def mic_3(self):
        return self._returns['mic-3']


class GetSourceFilters(BaseRequest):
    """
    List filters applied to a source

    :Arguments:
       *source_name*
            type: String
            Source name
    :Returns:
       *filters*
            type: Array<Object>
            List of filters for the specified source
       *filters.*.type*
            type: String
            Filter type
       *filters.*.name*
            type: String
            Filter name
       *filters.*.settings*
            type: Object
            Filter settings
    """
    def __init__(self, source_name):
        BaseRequest.__init__(self)
        self._name = 'GetSourceFilters'
        self._returns['filters'] = None
        self._params['sourceName'] = source_name

    @property
    def filters(self):
        return self._returns['filters']


class AddFilterToSource(BaseRequest):
    """
    Add a new filter to a source. Available source types along with their settings properties are available from `GetSourceTypesList`.

    :Arguments:
       *source_name*
            type: String
            Name of the source on which the filter is added
       *filter_name*
            type: String
            Name of the new filter
       *filter_type*
            type: String
            Filter type
       *filter_settings*
            type: Object
            Filter settings
    """
    def __init__(self, source_name, filter_name, filter_type, filter_settings):
        BaseRequest.__init__(self)
        self._name = 'AddFilterToSource'
        self._params['sourceName'] = source_name
        self._params['filterName'] = filter_name
        self._params['filterType'] = filter_type
        self._params['filterSettings'] = filter_settings


class RemoveFilterFromSource(BaseRequest):
    """
    Remove a filter from a source

    :Arguments:
       *source_name*
            type: String
            Name of the source from which the specified filter is removed
       *filter_name*
            type: String
            Name of the filter to remove
    """
    def __init__(self, source_name, filter_name):
        BaseRequest.__init__(self)
        self._name = 'RemoveFilterFromSource'
        self._params['sourceName'] = source_name
        self._params['filterName'] = filter_name


class ReorderSourceFilter(BaseRequest):
    """
    Move a filter in the chain (absolute index positioning)

    :Arguments:
       *source_name*
            type: String
            Name of the source to which the filter belongs
       *filter_name*
            type: String
            Name of the filter to reorder
       *new_index*
            type: Integer
            Desired position of the filter in the chain
    """
    def __init__(self, source_name, filter_name, new_index):
        BaseRequest.__init__(self)
        self._name = 'ReorderSourceFilter'
        self._params['sourceName'] = source_name
        self._params['filterName'] = filter_name
        self._params['newIndex'] = new_index


class MoveSourceFilter(BaseRequest):
    """
    Move a filter in the chain (relative positioning)

    :Arguments:
       *source_name*
            type: String
            Name of the source to which the filter belongs
       *filter_name*
            type: String
            Name of the filter to reorder
       *movement_type*
            type: String
            How to move the filter around in the source's filter chain. Either "up", "down", "top" or "bottom".
    """
    def __init__(self, source_name, filter_name, movement_type):
        BaseRequest.__init__(self)
        self._name = 'MoveSourceFilter'
        self._params['sourceName'] = source_name
        self._params['filterName'] = filter_name
        self._params['movementType'] = movement_type


class SetSourceFilterSettings(BaseRequest):
    """
    Update settings of a filter

    :Arguments:
       *source_name*
            type: String
            Name of the source to which the filter belongs
       *filter_name*
            type: String
            Name of the filter to reconfigure
       *filter_settings*
            type: Object
            New settings. These will be merged to the current filter settings.
    """
    def __init__(self, source_name, filter_name, filter_settings):
        BaseRequest.__init__(self)
        self._name = 'SetSourceFilterSettings'
        self._params['sourceName'] = source_name
        self._params['filterName'] = filter_name
        self._params['filterSettings'] = filter_settings


class TakeSourceScreenshot(BaseRequest):
    """
    
    
    At least `embedPictureFormat` or `saveToFilePath` must be specified.
    
    Clients can specify `width` and `height` parameters to receive scaled pictures. Aspect ratio is
    preserved if only one of these two parameters is specified.

    :Arguments:
       *source_name*
            type: String
            Source name
       *embed_picture_format*
            type: String (optional)
            Format of the Data URI encoded picture. Can be "png", "jpg", "jpeg" or "bmp" (or any other value supported by Qt's Image module)
       *save_to_file_path*
            type: String (optional)
            Full file path (file extension included) where the captured image is to be saved. Can be in a format different from `pictureFormat`. Can be a relative path.
       *width*
            type: int (optional)
            Screenshot width. Defaults to the source's base width.
       *height*
            type: int (optional)
            Screenshot height. Defaults to the source's base height.
    :Returns:
       *source_name*
            type: String
            Source name
       *img*
            type: String
            Image Data URI (if `embedPictureFormat` was specified in the request)
       *image_file*
            type: String
            Absolute path to the saved image file (if `saveToFilePath` was specified in the request)
    """
    def __init__(self, source_name, embed_picture_format=None, save_to_file_path=None, width=None, height=None):
        BaseRequest.__init__(self)
        self._name = 'TakeSourceScreenshot'
        self._returns['sourceName'] = None
        self._returns['img'] = None
        self._returns['imageFile'] = None
        self._params['sourceName'] = source_name
        self._params['embedPictureFormat'] = embed_picture_format
        self._params['saveToFilePath'] = save_to_file_path
        self._params['width'] = width
        self._params['height'] = height

    @property
    def source_name(self):
        return self._returns['sourceName']

    @property
    def img(self):
        return self._returns['img']

    @property
    def image_file(self):
        return self._returns['imageFile']


class GetStreamingStatus(BaseRequest):
    """
    Get current streaming and recording status.

    :Returns:
       *streaming*
            type: boolean
            Current streaming status.
       *recording*
            type: boolean
            Current recording status.
       *stream_timecode*
            type: String (optional)
            Time elapsed since streaming started (only present if currently streaming).
       *rec_timecode*
            type: String (optional)
            Time elapsed since recording started (only present if currently recording).
       *preview_only*
            type: boolean
            Always false. Retrocompatibility with OBSRemote.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetStreamingStatus'
        self._returns['streaming'] = None
        self._returns['recording'] = None
        self._returns['stream-timecode'] = None
        self._returns['rec-timecode'] = None
        self._returns['preview-only'] = None

    @property
    def streaming(self):
        return self._returns['streaming']

    @property
    def recording(self):
        return self._returns['recording']

    @property
    def stream_timecode(self):
        return self._returns['stream-timecode']

    @property
    def rec_timecode(self):
        return self._returns['rec-timecode']

    @property
    def preview_only(self):
        return self._returns['preview-only']


class StartStopStreaming(BaseRequest):
    """
    Toggle streaming on or off.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'StartStopStreaming'


class StartStreaming(BaseRequest):
    """
    Start streaming.
    Will return an `error` if streaming is already active.

    :Arguments:
       *stream*
            type: Object (optional)
            Special stream configuration. Please note: these won't be saved to OBS' configuration.
       *stream.type*
            type: String (optional)
            If specified ensures the type of stream matches the given type (usually 'rtmp_custom' or 'rtmp_common'). If the currently configured stream type does not match the given stream type, all settings must be specified in the `settings` object or an error will occur when starting the stream.
       *stream.metadata*
            type: Object (optional)
            Adds the given object parameters as encoded query string parameters to the 'key' of the RTMP stream. Used to pass data to the RTMP service about the streaming. May be any String, Numeric, or Boolean field.
       *stream.settings*
            type: Object (optional)
            Settings for the stream.
       *stream.settings.server*
            type: String (optional)
            The publish URL.
       *stream.settings.key*
            type: String (optional)
            The publish key of the stream.
       *stream.settings.use_auth*
            type: boolean (optional)
            Indicates whether authentication should be used when connecting to the streaming server.
       *stream.settings.username*
            type: String (optional)
            If authentication is enabled, the username for the streaming server. Ignored if `use-auth` is not set to `true`.
       *stream.settings.password*
            type: String (optional)
            If authentication is enabled, the password for the streaming server. Ignored if `use-auth` is not set to `true`.
    """
    def __init__(self, stream=None):
        BaseRequest.__init__(self)
        self._name = 'StartStreaming'
        self._params['stream'] = stream


class StopStreaming(BaseRequest):
    """
    Stop streaming.
    Will return an `error` if streaming is not active.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'StopStreaming'


class SetStreamSettings(BaseRequest):
    """
    Sets one or more attributes of the current streaming server settings. Any options not passed will remain unchanged. Returns the updated settings in response. If 'type' is different than the current streaming service type, all settings are required. Returns the full settings of the stream (the same as GetStreamSettings).

    :Arguments:
       *type*
            type: String
            The type of streaming service configuration, usually `rtmp_custom` or `rtmp_common`.
       *settings*
            type: Object
            The actual settings of the stream.
       *settings.server*
            type: String (optional)
            The publish URL.
       *settings.key*
            type: String (optional)
            The publish key.
       *settings.use_auth*
            type: boolean (optional)
            Indicates whether authentication should be used when connecting to the streaming server.
       *settings.username*
            type: String (optional)
            The username for the streaming service.
       *settings.password*
            type: String (optional)
            The password for the streaming service.
       *save*
            type: boolean
            Persist the settings to disk.
    """
    def __init__(self, type, settings, save):
        BaseRequest.__init__(self)
        self._name = 'SetStreamSettings'
        self._params['type'] = type
        self._params['settings'] = settings
        self._params['save'] = save


class GetStreamSettings(BaseRequest):
    """
    Get the current streaming server settings.

    :Returns:
       *type*
            type: String
            The type of streaming service configuration. Possible values: 'rtmp_custom' or 'rtmp_common'.
       *settings*
            type: Object
            Stream settings object.
       *settings.server*
            type: String
            The publish URL.
       *settings.key*
            type: String
            The publish key of the stream.
       *settings.use_auth*
            type: boolean
            Indicates whether authentication should be used when connecting to the streaming server.
       *settings.username*
            type: String
            The username to use when accessing the streaming server. Only present if `use-auth` is `true`.
       *settings.password*
            type: String
            The password to use when accessing the streaming server. Only present if `use-auth` is `true`.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetStreamSettings'
        self._returns['type'] = None
        self._returns['settings'] = None

    @property
    def type(self):
        return self._returns['type']

    @property
    def settings(self):
        return self._returns['settings']


class SaveStreamSettings(BaseRequest):
    """
    Save the current streaming server settings to disk.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'SaveStreamSettings'


class SendCaptions(BaseRequest):
    """
    Send the provided text as embedded CEA-608 caption data.
    As of OBS Studio 23.1, captions are not yet available on Linux.

    :Arguments:
       *text*
            type: String
            Captions text
    """
    def __init__(self, text):
        BaseRequest.__init__(self)
        self._name = 'SendCaptions'
        self._params['text'] = text


class GetStudioModeStatus(BaseRequest):
    """
    Indicates if Studio Mode is currently enabled.

    :Returns:
       *studio_mode*
            type: boolean
            Indicates if Studio Mode is enabled.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetStudioModeStatus'
        self._returns['studio-mode'] = None

    @property
    def studio_mode(self):
        return self._returns['studio-mode']


class GetPreviewScene(BaseRequest):
    """
    Get the name of the currently previewed scene and its list of sources.
    Will return an `error` if Studio Mode is not enabled.

    :Returns:
       *name*
            type: String
            The name of the active preview scene.
       *sources*
            type: Array<SceneItem>
            
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetPreviewScene'
        self._returns['name'] = None
        self._returns['sources'] = None

    @property
    def name(self):
        return self._returns['name']

    @property
    def sources(self):
        return self._returns['sources']


class SetPreviewScene(BaseRequest):
    """
    Set the active preview scene.
    Will return an `error` if Studio Mode is not enabled.

    :Arguments:
       *scene_name*
            type: String
            The name of the scene to preview.
    """
    def __init__(self, scene_name):
        BaseRequest.__init__(self)
        self._name = 'SetPreviewScene'
        self._params['scene-name'] = scene_name


class TransitionToProgram(BaseRequest):
    """
    Transitions the currently previewed scene to the main output.
    Will return an `error` if Studio Mode is not enabled.

    :Arguments:
       *with_transition*
            type: Object (optional)
            Change the active transition before switching scenes. Defaults to the active transition.
       *with_transition.name*
            type: String
            Name of the transition.
       *with_transition.duration*
            type: int (optional)
            Transition duration (in milliseconds).
    """
    def __init__(self, with_transition=None):
        BaseRequest.__init__(self)
        self._name = 'TransitionToProgram'
        self._params['with-transition'] = with_transition


class EnableStudioMode(BaseRequest):
    """
    Enables Studio Mode.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'EnableStudioMode'


class DisableStudioMode(BaseRequest):
    """
    Disables Studio Mode.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'DisableStudioMode'


class ToggleStudioMode(BaseRequest):
    """
    Toggles Studio Mode.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'ToggleStudioMode'


class GetTransitionList(BaseRequest):
    """
    List of all transitions available in the frontend's dropdown menu.

    :Returns:
       *current_transition*
            type: String
            Name of the currently active transition.
       *transitions*
            type: Array<Object>
            List of transitions.
       *transitions.*.name*
            type: String
            Name of the transition.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetTransitionList'
        self._returns['current-transition'] = None
        self._returns['transitions'] = None

    @property
    def current_transition(self):
        return self._returns['current-transition']

    @property
    def transitions(self):
        return self._returns['transitions']


class GetCurrentTransition(BaseRequest):
    """
    Get the name of the currently selected transition in the frontend's dropdown menu.

    :Returns:
       *name*
            type: String
            Name of the selected transition.
       *duration*
            type: int (optional)
            Transition duration (in milliseconds) if supported by the transition.
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetCurrentTransition'
        self._returns['name'] = None
        self._returns['duration'] = None

    @property
    def name(self):
        return self._returns['name']

    @property
    def duration(self):
        return self._returns['duration']


class SetCurrentTransition(BaseRequest):
    """
    Set the active transition.

    :Arguments:
       *transition_name*
            type: String
            The name of the transition.
    """
    def __init__(self, transition_name):
        BaseRequest.__init__(self)
        self._name = 'SetCurrentTransition'
        self._params['transition-name'] = transition_name


class SetTransitionDuration(BaseRequest):
    """
    Set the duration of the currently selected transition if supported.

    :Arguments:
       *duration*
            type: int
            Desired duration of the transition (in milliseconds).
    """
    def __init__(self, duration):
        BaseRequest.__init__(self)
        self._name = 'SetTransitionDuration'
        self._params['duration'] = duration


class GetTransitionDuration(BaseRequest):
    """
    Get the duration of the currently selected transition if supported.

    :Returns:
       *transition_duration*
            type: int
            Duration of the current transition (in milliseconds).
    """
    def __init__(self):
        BaseRequest.__init__(self)
        self._name = 'GetTransitionDuration'
        self._returns['transition-duration'] = None

    @property
    def transition_duration(self):
        return self._returns['transition-duration']


